diff --git a/gcc/cp/constraint.cc b/gcc/cp/constraint.cc
index f0d3f89464c..d0464dd4f6a 100644
--- a/gcc/cp/constraint.cc
+++ b/gcc/cp/constraint.cc
@@ -3756,6 +3756,9 @@ diagnose_trait_expr (tree expr, tree args)
     case CPTK_IS_LITERAL_TYPE:
       inform (loc, "  %qT is not a literal type", t1);
       break;
+    case CPTK_IS_MEMBER_FUNCTION_POINTER:
+      inform (loc, "  %qT is not a member function pointer", t1);
+      break;
     case CPTK_IS_MEMBER_POINTER:
       inform (loc, "  %qT is not a member pointer", t1);
       break;
diff --git a/gcc/cp/cp-trait.def b/gcc/cp/cp-trait.def
index 26087da3bdf..897b96630f2 100644
--- a/gcc/cp/cp-trait.def
+++ b/gcc/cp/cp-trait.def
@@ -72,6 +72,7 @@ DEFTRAIT_EXPR (IS_ENUM, "__is_enum", 1)
 DEFTRAIT_EXPR (IS_FINAL, "__is_final", 1)
 DEFTRAIT_EXPR (IS_LAYOUT_COMPATIBLE, "__is_layout_compatible", 2)
 DEFTRAIT_EXPR (IS_LITERAL_TYPE, "__is_literal_type", 1)
+DEFTRAIT_EXPR (IS_MEMBER_FUNCTION_POINTER, "__is_member_function_pointer", 1)
 DEFTRAIT_EXPR (IS_MEMBER_POINTER, "__is_member_pointer", 1)
 DEFTRAIT_EXPR (IS_NOTHROW_ASSIGNABLE, "__is_nothrow_assignable", 2)
 DEFTRAIT_EXPR (IS_NOTHROW_CONSTRUCTIBLE, "__is_nothrow_constructible", -1)
diff --git a/gcc/cp/cp-trait.gperf b/gcc/cp/cp-trait.gperf
index 3775b11283d..b28efbab322 100644
--- a/gcc/cp/cp-trait.gperf
+++ b/gcc/cp/cp-trait.gperf
@@ -52,6 +52,7 @@ struct cp_trait {
 "__is_final", CPTK_IS_FINAL, 1, false
 "__is_layout_compatible", CPTK_IS_LAYOUT_COMPATIBLE, 2, false
 "__is_literal_type", CPTK_IS_LITERAL_TYPE, 1, false
+"__is_member_function_pointer", CPTK_IS_MEMBER_FUNCTION_POINTER, 1, false
 "__is_member_pointer", CPTK_IS_MEMBER_POINTER, 1, false
 "__is_nothrow_assignable", CPTK_IS_NOTHROW_ASSIGNABLE, 2, false
 "__is_nothrow_constructible", CPTK_IS_NOTHROW_CONSTRUCTIBLE, -1, false
diff --git a/gcc/cp/cp-trait.h b/gcc/cp/cp-trait.h
index dfd60cec6e6..d3d4bdf9799 100644
--- a/gcc/cp/cp-trait.h
+++ b/gcc/cp/cp-trait.h
@@ -54,7 +54,7 @@ struct cp_trait {
   short arity;
   bool type;
 };
-/* maximum key range = 111, duplicates = 0 */
+/* maximum key range = 89, duplicates = 0 */
 
 class cp_trait_lookup
 {
@@ -69,32 +69,32 @@ cp_trait_lookup::hash (const char *str, size_t len)
 {
   static const unsigned char asso_values[] =
     {
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118,  20, 118,   0,  55,  50,
-       40,   0,  40,  20, 118,   0, 118, 118,   5,   5,
-       30,   0,   5, 118,  10,  50,   5,   0,   5, 118,
-      118,   5, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
-      118, 118, 118, 118, 118, 118
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 20, 96, 40,  5, 40,
+      40,  0, 25, 10, 96,  0, 96, 96,  5, 25,
+      30,  0,  5, 96, 10, 15,  5,  0, 25, 96,
+      96, 20, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96
     };
   unsigned int hval = len;
 
@@ -116,132 +116,132 @@ cp_trait_lookup::find (const char *str, size_t len)
 {
   enum
     {
-      TOTAL_KEYWORDS = 52,
+      TOTAL_KEYWORDS = 53,
       MIN_WORD_LENGTH = 7,
       MAX_WORD_LENGTH = 37,
       MIN_HASH_VALUE = 7,
-      MAX_HASH_VALUE = 117
+      MAX_HASH_VALUE = 95
     };
 
   static const struct cp_trait wordlist[] =
     {
-#line 80 "../../gcc/cp/cp-trait.gperf"
+#line 81 "../../gcc/cp/cp-trait.gperf"
       {"__bases", CPTK_BASES, 1, true},
 #line 51 "../../gcc/cp/cp-trait.gperf"
       {"__is_enum", CPTK_IS_ENUM, 1, false},
-#line 70 "../../gcc/cp/cp-trait.gperf"
+#line 71 "../../gcc/cp/cp-trait.gperf"
       {"__is_union", CPTK_IS_UNION, 1, false},
-#line 74 "../../gcc/cp/cp-trait.gperf"
-      {"__remove_cv", CPTK_REMOVE_CV, 1, true},
 #line 75 "../../gcc/cp/cp-trait.gperf"
+      {"__remove_cv", CPTK_REMOVE_CV, 1, true},
+#line 76 "../../gcc/cp/cp-trait.gperf"
       {"__remove_cvref", CPTK_REMOVE_CVREF, 1, true},
 #line 50 "../../gcc/cp/cp-trait.gperf"
       {"__is_empty", CPTK_IS_EMPTY, 1, false},
-#line 65 "../../gcc/cp/cp-trait.gperf"
+#line 66 "../../gcc/cp/cp-trait.gperf"
       {"__is_trivial", CPTK_IS_TRIVIAL, 1, false},
-#line 76 "../../gcc/cp/cp-trait.gperf"
+#line 77 "../../gcc/cp/cp-trait.gperf"
       {"__remove_reference", CPTK_REMOVE_REFERENCE, 1, true},
-#line 81 "../../gcc/cp/cp-trait.gperf"
+#line 82 "../../gcc/cp/cp-trait.gperf"
       {"__direct_bases", CPTK_DIRECT_BASES, 1, true},
-#line 42 "../../gcc/cp/cp-trait.gperf"
-      {"__is_array", CPTK_IS_ARRAY, 1, false},
-#line 78 "../../gcc/cp/cp-trait.gperf"
+#line 79 "../../gcc/cp/cp-trait.gperf"
       {"__underlying_type", CPTK_UNDERLYING_TYPE, 1, true},
-#line 71 "../../gcc/cp/cp-trait.gperf"
-      {"__is_volatile", CPTK_IS_VOLATILE, 1, false},
-#line 77 "../../gcc/cp/cp-trait.gperf"
+#line 45 "../../gcc/cp/cp-trait.gperf"
+      {"__is_bounded_array", CPTK_IS_BOUNDED_ARRAY, 1, false},
+#line 78 "../../gcc/cp/cp-trait.gperf"
       {"__type_pack_element", CPTK_TYPE_PACK_ELEMENT, -1, true},
-#line 61 "../../gcc/cp/cp-trait.gperf"
+#line 70 "../../gcc/cp/cp-trait.gperf"
+      {"__is_unbounded_array", CPTK_IS_UNBOUNDED_ARRAY, 1, false},
+#line 62 "../../gcc/cp/cp-trait.gperf"
       {"__is_polymorphic", CPTK_IS_POLYMORPHIC, 1, false},
 #line 54 "../../gcc/cp/cp-trait.gperf"
       {"__is_literal_type", CPTK_IS_LITERAL_TYPE, 1, false},
-#line 68 "../../gcc/cp/cp-trait.gperf"
+#line 69 "../../gcc/cp/cp-trait.gperf"
       {"__is_trivially_copyable", CPTK_IS_TRIVIALLY_COPYABLE, 1, false},
-#line 55 "../../gcc/cp/cp-trait.gperf"
-      {"__is_member_pointer", CPTK_IS_MEMBER_POINTER, 1, false},
-#line 66 "../../gcc/cp/cp-trait.gperf"
-      {"__is_trivially_assignable", CPTK_IS_TRIVIALLY_ASSIGNABLE, 2, false},
-#line 53 "../../gcc/cp/cp-trait.gperf"
-      {"__is_layout_compatible", CPTK_IS_LAYOUT_COMPATIBLE, 2, false},
 #line 67 "../../gcc/cp/cp-trait.gperf"
+      {"__is_trivially_assignable", CPTK_IS_TRIVIALLY_ASSIGNABLE, 2, false},
+#line 64 "../../gcc/cp/cp-trait.gperf"
+      {"__is_scoped_enum", CPTK_IS_SCOPED_ENUM, 1, false},
+#line 44 "../../gcc/cp/cp-trait.gperf"
+      {"__is_base_of", CPTK_IS_BASE_OF, 2, false},
+#line 68 "../../gcc/cp/cp-trait.gperf"
       {"__is_trivially_constructible", CPTK_IS_TRIVIALLY_CONSTRUCTIBLE, -1, false},
-#line 41 "../../gcc/cp/cp-trait.gperf"
-      {"__is_aggregate", CPTK_IS_AGGREGATE, 1, false},
-#line 73 "../../gcc/cp/cp-trait.gperf"
+#line 74 "../../gcc/cp/cp-trait.gperf"
       {"__reference_converts_from_temporary", CPTK_REF_CONVERTS_FROM_TEMPORARY, 2, false},
-#line 72 "../../gcc/cp/cp-trait.gperf"
+#line 73 "../../gcc/cp/cp-trait.gperf"
       {"__reference_constructs_from_temporary", CPTK_REF_CONSTRUCTS_FROM_TEMPORARY, 2, false},
 #line 33 "../../gcc/cp/cp-trait.gperf"
       {"__has_nothrow_copy", CPTK_HAS_NOTHROW_COPY, 1, false},
 #line 31 "../../gcc/cp/cp-trait.gperf"
       {"__has_nothrow_assign", CPTK_HAS_NOTHROW_ASSIGN, 1, false},
-#line 59 "../../gcc/cp/cp-trait.gperf"
+#line 60 "../../gcc/cp/cp-trait.gperf"
       {"__is_pointer_interconvertible_base_of", CPTK_IS_POINTER_INTERCONVERTIBLE_BASE_OF, 2, false},
+#line 72 "../../gcc/cp/cp-trait.gperf"
+      {"__is_volatile", CPTK_IS_VOLATILE, 1, false},
 #line 39 "../../gcc/cp/cp-trait.gperf"
       {"__has_virtual_destructor", CPTK_HAS_VIRTUAL_DESTRUCTOR, 1, false},
 #line 32 "../../gcc/cp/cp-trait.gperf"
       {"__has_nothrow_constructor", CPTK_HAS_NOTHROW_CONSTRUCTOR, 1, false},
+#line 53 "../../gcc/cp/cp-trait.gperf"
+      {"__is_layout_compatible", CPTK_IS_LAYOUT_COMPATIBLE, 2, false},
 #line 36 "../../gcc/cp/cp-trait.gperf"
       {"__has_trivial_copy", CPTK_HAS_TRIVIAL_COPY, 1, false},
+#line 63 "../../gcc/cp/cp-trait.gperf"
+      {"__is_same", CPTK_IS_SAME, 2, false},
 #line 34 "../../gcc/cp/cp-trait.gperf"
       {"__has_trivial_assign", CPTK_HAS_TRIVIAL_ASSIGN, 1, false},
-#line 60 "../../gcc/cp/cp-trait.gperf"
+#line 30 "../../gcc/cp/cp-trait.gperf"
+      {"__is_same_as", CPTK_IS_SAME, 2, false},
+#line 61 "../../gcc/cp/cp-trait.gperf"
       {"__is_pod", CPTK_IS_POD, 1, false},
 #line 37 "../../gcc/cp/cp-trait.gperf"
       {"__has_trivial_destructor", CPTK_HAS_TRIVIAL_DESTRUCTOR, 1, false},
 #line 35 "../../gcc/cp/cp-trait.gperf"
       {"__has_trivial_constructor", CPTK_HAS_TRIVIAL_CONSTRUCTOR, 1, false},
-#line 56 "../../gcc/cp/cp-trait.gperf"
+#line 57 "../../gcc/cp/cp-trait.gperf"
       {"__is_nothrow_assignable", CPTK_IS_NOTHROW_ASSIGNABLE, 2, false},
-#line 58 "../../gcc/cp/cp-trait.gperf"
+#line 59 "../../gcc/cp/cp-trait.gperf"
       {"__is_nothrow_convertible", CPTK_IS_NOTHROW_CONVERTIBLE, 2, false},
-#line 46 "../../gcc/cp/cp-trait.gperf"
-      {"__is_class", CPTK_IS_CLASS, 1, false},
-#line 57 "../../gcc/cp/cp-trait.gperf"
+#line 42 "../../gcc/cp/cp-trait.gperf"
+      {"__is_array", CPTK_IS_ARRAY, 1, false},
+#line 58 "../../gcc/cp/cp-trait.gperf"
       {"__is_nothrow_constructible", CPTK_IS_NOTHROW_CONSTRUCTIBLE, -1, false},
+#line 41 "../../gcc/cp/cp-trait.gperf"
+      {"__is_aggregate", CPTK_IS_AGGREGATE, 1, false},
+#line 52 "../../gcc/cp/cp-trait.gperf"
+      {"__is_final", CPTK_IS_FINAL, 1, false},
 #line 40 "../../gcc/cp/cp-trait.gperf"
       {"__is_abstract", CPTK_IS_ABSTRACT, 1, false},
-#line 62 "../../gcc/cp/cp-trait.gperf"
-      {"__is_same", CPTK_IS_SAME, 2, false},
+#line 56 "../../gcc/cp/cp-trait.gperf"
+      {"__is_member_pointer", CPTK_IS_MEMBER_POINTER, 1, false},
 #line 43 "../../gcc/cp/cp-trait.gperf"
       {"__is_assignable", CPTK_IS_ASSIGNABLE, 2, false},
-#line 63 "../../gcc/cp/cp-trait.gperf"
-      {"__is_scoped_enum", CPTK_IS_SCOPED_ENUM, 1, false},
-#line 30 "../../gcc/cp/cp-trait.gperf"
-      {"__is_same_as", CPTK_IS_SAME, 2, false},
-#line 64 "../../gcc/cp/cp-trait.gperf"
+#line 65 "../../gcc/cp/cp-trait.gperf"
       {"__is_standard_layout", CPTK_IS_STD_LAYOUT, 1, false},
-#line 45 "../../gcc/cp/cp-trait.gperf"
-      {"__is_bounded_array", CPTK_IS_BOUNDED_ARRAY, 1, false},
-#line 69 "../../gcc/cp/cp-trait.gperf"
-      {"__is_unbounded_array", CPTK_IS_UNBOUNDED_ARRAY, 1, false},
-#line 52 "../../gcc/cp/cp-trait.gperf"
-      {"__is_final", CPTK_IS_FINAL, 1, false},
-#line 38 "../../gcc/cp/cp-trait.gperf"
-      {"__has_unique_object_representations", CPTK_HAS_UNIQUE_OBJ_REPRESENTATIONS, 1, false},
+#line 55 "../../gcc/cp/cp-trait.gperf"
+      {"__is_member_function_pointer", CPTK_IS_MEMBER_FUNCTION_POINTER, 1, false},
 #line 47 "../../gcc/cp/cp-trait.gperf"
       {"__is_const", CPTK_IS_CONST, 1, false},
-#line 79 "../../gcc/cp/cp-trait.gperf"
-      {"__is_deducible ", CPTK_IS_DEDUCIBLE, 2, false},
+#line 38 "../../gcc/cp/cp-trait.gperf"
+      {"__has_unique_object_representations", CPTK_HAS_UNIQUE_OBJ_REPRESENTATIONS, 1, false},
 #line 49 "../../gcc/cp/cp-trait.gperf"
       {"__is_convertible", CPTK_IS_CONVERTIBLE, 2, false},
 #line 48 "../../gcc/cp/cp-trait.gperf"
       {"__is_constructible", CPTK_IS_CONSTRUCTIBLE, -1, false},
-#line 44 "../../gcc/cp/cp-trait.gperf"
-      {"__is_base_of", CPTK_IS_BASE_OF, 2, false}
+#line 46 "../../gcc/cp/cp-trait.gperf"
+      {"__is_class", CPTK_IS_CLASS, 1, false},
+#line 80 "../../gcc/cp/cp-trait.gperf"
+      {"__is_deducible ", CPTK_IS_DEDUCIBLE, 2, false}
     };
 
   static const signed char lookup[] =
     {
       -1, -1, -1, -1, -1, -1, -1,  0, -1,  1,  2,  3, -1, -1,
-       4,  5, -1,  6,  7,  8,  9, -1, 10, 11, 12, -1, 13, 14,
-      15, 16, 17, -1, 18, 19, 20, 21, -1, 22, 23, -1, 24, -1,
-      25, -1, 26, 27, -1, -1, 28, -1, 29, -1, -1, 30, 31, 32,
-      -1, -1, 33, 34, 35, 36, -1, 37, 38, 39, 40, 41, -1, -1,
-      42, -1, -1, 43, -1, 44, -1, -1, -1, -1, 45, -1, -1, -1,
-      -1, 46, -1, -1, -1, -1, 47, -1, -1, -1, -1, 48, 49, -1,
-      50, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
-      -1, -1, -1, -1, -1, 51
+       4,  5, -1,  6,  7,  8, -1, -1,  9, 10, 11, 12, 13, 14,
+      15, -1, 16, 17, 18, 19, -1, 20, -1, 21, 22, -1, 23, -1,
+      24, 25, 26, 27, -1, 28, 29, 30, 31, -1, 32, 33, 34, 35,
+      -1, -1, 36, 37, 38, 39, -1, -1, 40, 41, -1, -1, 42, 43,
+      44, -1, -1, -1, -1, 45, -1, -1, 46, -1, 47, -1, -1, -1,
+      -1, 48, 49, -1, 50, -1, 51, -1, -1, -1, -1, 52
     };
 
   if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
diff --git a/gcc/cp/semantics.cc b/gcc/cp/semantics.cc
index 6c4880d8a33..4d521f87bbb 100644
--- a/gcc/cp/semantics.cc
+++ b/gcc/cp/semantics.cc
@@ -12184,6 +12184,9 @@ trait_expr_value (cp_trait_kind kind, tree type1, tree type2)
     case CPTK_IS_LITERAL_TYPE:
       return literal_type_p (type1);
 
+    case CPTK_IS_MEMBER_FUNCTION_POINTER:
+      return TYPE_PTRMEMFUNC_P (type1);
+
     case CPTK_IS_MEMBER_POINTER:
       return TYPE_PTRMEM_P (type1);
 
@@ -12396,6 +12399,7 @@ finish_trait_expr (location_t loc, cp_trait_kind kind, tree type1, tree type2)
     case CPTK_IS_CLASS:
     case CPTK_IS_CONST:
     case CPTK_IS_ENUM:
+    case CPTK_IS_MEMBER_FUNCTION_POINTER:
     case CPTK_IS_MEMBER_POINTER:
     case CPTK_IS_SAME:
     case CPTK_IS_SCOPED_ENUM:
diff --git a/gcc/testsuite/g++.dg/ext/has-builtin-1.C b/gcc/testsuite/g++.dg/ext/has-builtin-1.C
index 994873f14e9..0dfe957474b 100644
--- a/gcc/testsuite/g++.dg/ext/has-builtin-1.C
+++ b/gcc/testsuite/g++.dg/ext/has-builtin-1.C
@@ -95,6 +95,9 @@
 #if !__has_builtin (__is_literal_type)
 # error "__has_builtin (__is_literal_type) failed"
 #endif
+#if !__has_builtin (__is_member_function_pointer)
+# error "__has_builtin (__is_member_function_pointer) failed"
+#endif
 #if !__has_builtin (__is_member_pointer)
 # error "__has_builtin (__is_member_pointer) failed"
 #endif
diff --git a/gcc/testsuite/g++.dg/ext/is_member_function_pointer.C b/gcc/testsuite/g++.dg/ext/is_member_function_pointer.C
new file mode 100644
index 00000000000..555123e8f07
--- /dev/null
+++ b/gcc/testsuite/g++.dg/ext/is_member_function_pointer.C
@@ -0,0 +1,31 @@
+// { dg-do compile { target c++11 } }
+
+#include <testsuite_tr1.h>
+
+using namespace __gnu_test;
+
+#define SA(X) static_assert((X),#X)
+
+#define SA_TEST_FN(TRAIT, TYPE, EXPECT)	\
+  SA(TRAIT(TYPE) == EXPECT);			\
+  SA(TRAIT(const TYPE) == EXPECT);
+
+#define SA_TEST_CATEGORY(TRAIT, TYPE, EXPECT)	\
+  SA(TRAIT(TYPE) == EXPECT);					\
+  SA(TRAIT(const TYPE) == EXPECT);				\
+  SA(TRAIT(volatile TYPE) == EXPECT);			\
+  SA(TRAIT(const volatile TYPE) == EXPECT)
+
+// Positive tests.
+SA_TEST_FN(__is_member_function_pointer, int (ClassType::*) (int), true);
+SA_TEST_FN(__is_member_function_pointer, int (ClassType::*) (int) const, true);
+SA_TEST_FN(__is_member_function_pointer, int (ClassType::*) (float, ...), true);
+SA_TEST_FN(__is_member_function_pointer, ClassType (ClassType::*) (ClassType), true);
+SA_TEST_FN(__is_member_function_pointer, float (ClassType::*) (int, float, int[], int&), true);
+
+// Negative tests.
+SA_TEST_CATEGORY(__is_member_function_pointer, int (ClassType::*), false);
+SA_TEST_CATEGORY(__is_member_function_pointer, ClassType (ClassType::*), false);
+
+// Sanity check.
+SA_TEST_CATEGORY(__is_member_function_pointer, ClassType, false);