diff --git a/gcc/cp/constraint.cc b/gcc/cp/constraint.cc
index 3a7f968eae8..c28dad702c3 100644
--- a/gcc/cp/constraint.cc
+++ b/gcc/cp/constraint.cc
@@ -3829,6 +3829,9 @@ diagnose_trait_expr (tree expr, tree args)
     case CPTK_IS_UNION:
       inform (loc, "  %qT is not a union", t1);
       break;
+    case CPTK_IS_UNSIGNED:
+      inform (loc, "  %qT is not an unsigned type", t1);
+      break;
     case CPTK_IS_VOLATILE:
       inform (loc, "  %qT is not a volatile type", t1);
       break;
diff --git a/gcc/cp/cp-trait.def b/gcc/cp/cp-trait.def
index b2be7b7bbd7..0603b4a230f 100644
--- a/gcc/cp/cp-trait.def
+++ b/gcc/cp/cp-trait.def
@@ -94,6 +94,7 @@ DEFTRAIT_EXPR (IS_TRIVIALLY_CONSTRUCTIBLE, "__is_trivially_constructible", -1)
 DEFTRAIT_EXPR (IS_TRIVIALLY_COPYABLE, "__is_trivially_copyable", 1)
 DEFTRAIT_EXPR (IS_UNBOUNDED_ARRAY, "__is_unbounded_array", 1)
 DEFTRAIT_EXPR (IS_UNION, "__is_union", 1)
+DEFTRAIT_EXPR (IS_UNSIGNED, "__is_unsigned", 1)
 DEFTRAIT_EXPR (IS_VOLATILE, "__is_volatile", 1)
 DEFTRAIT_EXPR (REF_CONSTRUCTS_FROM_TEMPORARY, "__reference_constructs_from_temporary", 2)
 DEFTRAIT_EXPR (REF_CONVERTS_FROM_TEMPORARY, "__reference_converts_from_temporary", 2)
diff --git a/gcc/cp/cp-trait.gperf b/gcc/cp/cp-trait.gperf
index 9050c36f105..90d05bca5c1 100644
--- a/gcc/cp/cp-trait.gperf
+++ b/gcc/cp/cp-trait.gperf
@@ -74,6 +74,7 @@ struct cp_trait {
 "__is_trivially_copyable", CPTK_IS_TRIVIALLY_COPYABLE, 1, false
 "__is_unbounded_array", CPTK_IS_UNBOUNDED_ARRAY, 1, false
 "__is_union", CPTK_IS_UNION, 1, false
+"__is_unsigned", CPTK_IS_UNSIGNED, 1, false
 "__is_volatile", CPTK_IS_VOLATILE, 1, false
 "__reference_constructs_from_temporary", CPTK_REF_CONSTRUCTS_FROM_TEMPORARY, 2, false
 "__reference_converts_from_temporary", CPTK_REF_CONVERTS_FROM_TEMPORARY, 2, false
diff --git a/gcc/cp/cp-trait.h b/gcc/cp/cp-trait.h
index 31fd5075f2d..75ab2b5edfa 100644
--- a/gcc/cp/cp-trait.h
+++ b/gcc/cp/cp-trait.h
@@ -54,7 +54,7 @@ struct cp_trait {
   short arity;
   bool type;
 };
-/* maximum key range = 97, duplicates = 0 */
+/* maximum key range = 129, duplicates = 0 */
 
 class cp_trait_lookup
 {
@@ -69,32 +69,32 @@ cp_trait_lookup::hash (const char *str, size_t len)
 {
   static const unsigned char asso_values[] =
     {
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104,  20, 104,  45,  50,  40,
-        5,   0,  55,   0, 104,   0, 104, 104,  10,  15,
-       35,   0,  10, 104,  10,  15,   5,   0,  20, 104,
-      104,  20, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104, 104, 104, 104, 104,
-      104, 104, 104, 104, 104, 104
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136,  20, 136,  45,  35,  40,
+       60,   0,  55,   0, 136,   0, 136, 136,  10,  15,
+       35,   0,  10, 136,  10,  15,   5,  15,   0, 136,
+      136,  20, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136, 136, 136, 136, 136,
+      136, 136, 136, 136, 136, 136
     };
   unsigned int hval = len;
 
@@ -116,46 +116,44 @@ cp_trait_lookup::find (const char *str, size_t len)
 {
   enum
     {
-      TOTAL_KEYWORDS = 59,
+      TOTAL_KEYWORDS = 60,
       MIN_WORD_LENGTH = 7,
       MAX_WORD_LENGTH = 37,
       MIN_HASH_VALUE = 7,
-      MAX_HASH_VALUE = 103
+      MAX_HASH_VALUE = 135
     };
 
   static const struct cp_trait wordlist[] =
     {
-#line 87 "../../gcc/cp/cp-trait.gperf"
+#line 88 "../../gcc/cp/cp-trait.gperf"
       {"__bases", CPTK_BASES, 1, true},
-#line 52 "../../gcc/cp/cp-trait.gperf"
-      {"__is_enum", CPTK_IS_ENUM, 1, false},
-#line 76 "../../gcc/cp/cp-trait.gperf"
-      {"__is_union", CPTK_IS_UNION, 1, false},
-#line 80 "../../gcc/cp/cp-trait.gperf"
-      {"__remove_cv", CPTK_REMOVE_CV, 1, true},
 #line 81 "../../gcc/cp/cp-trait.gperf"
-      {"__remove_cvref", CPTK_REMOVE_CVREF, 1, true},
+      {"__remove_cv", CPTK_REMOVE_CV, 1, true},
 #line 82 "../../gcc/cp/cp-trait.gperf"
+      {"__remove_cvref", CPTK_REMOVE_CVREF, 1, true},
+#line 83 "../../gcc/cp/cp-trait.gperf"
       {"__remove_pointer", CPTK_REMOVE_POINTER, 1, true},
 #line 71 "../../gcc/cp/cp-trait.gperf"
       {"__is_trivial", CPTK_IS_TRIVIAL, 1, false},
-#line 83 "../../gcc/cp/cp-trait.gperf"
+#line 84 "../../gcc/cp/cp-trait.gperf"
       {"__remove_reference", CPTK_REMOVE_REFERENCE, 1, true},
-#line 88 "../../gcc/cp/cp-trait.gperf"
+#line 89 "../../gcc/cp/cp-trait.gperf"
       {"__direct_bases", CPTK_DIRECT_BASES, 1, true},
 #line 51 "../../gcc/cp/cp-trait.gperf"
       {"__is_empty", CPTK_IS_EMPTY, 1, false},
 #line 65 "../../gcc/cp/cp-trait.gperf"
       {"__is_pointer", CPTK_IS_POINTER, 1, false},
-#line 64 "../../gcc/cp/cp-trait.gperf"
-      {"__is_pod", CPTK_IS_POD, 1, false},
+#line 78 "../../gcc/cp/cp-trait.gperf"
+      {"__is_volatile", CPTK_IS_VOLATILE, 1, false},
+#line 52 "../../gcc/cp/cp-trait.gperf"
+      {"__is_enum", CPTK_IS_ENUM, 1, false},
+#line 76 "../../gcc/cp/cp-trait.gperf"
+      {"__is_union", CPTK_IS_UNION, 1, false},
 #line 86 "../../gcc/cp/cp-trait.gperf"
-      {"__is_deducible ", CPTK_IS_DEDUCIBLE, 2, false},
-#line 85 "../../gcc/cp/cp-trait.gperf"
       {"__underlying_type", CPTK_UNDERLYING_TYPE, 1, true},
 #line 74 "../../gcc/cp/cp-trait.gperf"
       {"__is_trivially_copyable", CPTK_IS_TRIVIALLY_COPYABLE, 1, false},
-#line 84 "../../gcc/cp/cp-trait.gperf"
+#line 85 "../../gcc/cp/cp-trait.gperf"
       {"__type_pack_element", CPTK_TYPE_PACK_ELEMENT, -1, true},
 #line 72 "../../gcc/cp/cp-trait.gperf"
       {"__is_trivially_assignable", CPTK_IS_TRIVIALLY_ASSIGNABLE, 2, false},
@@ -165,11 +163,11 @@ cp_trait_lookup::find (const char *str, size_t len)
       {"__is_literal_type", CPTK_IS_LITERAL_TYPE, 1, false},
 #line 73 "../../gcc/cp/cp-trait.gperf"
       {"__is_trivially_constructible", CPTK_IS_TRIVIALLY_CONSTRUCTIBLE, -1, false},
-#line 79 "../../gcc/cp/cp-trait.gperf"
+#line 80 "../../gcc/cp/cp-trait.gperf"
       {"__reference_converts_from_temporary", CPTK_REF_CONVERTS_FROM_TEMPORARY, 2, false},
 #line 66 "../../gcc/cp/cp-trait.gperf"
       {"__is_polymorphic", CPTK_IS_POLYMORPHIC, 1, false},
-#line 78 "../../gcc/cp/cp-trait.gperf"
+#line 79 "../../gcc/cp/cp-trait.gperf"
       {"__reference_constructs_from_temporary", CPTK_REF_CONSTRUCTS_FROM_TEMPORARY, 2, false},
 #line 33 "../../gcc/cp/cp-trait.gperf"
       {"__has_nothrow_copy", CPTK_HAS_NOTHROW_COPY, 1, false},
@@ -180,7 +178,7 @@ cp_trait_lookup::find (const char *str, size_t len)
 #line 30 "../../gcc/cp/cp-trait.gperf"
       {"__is_same_as", CPTK_IS_SAME, 2, false},
 #line 77 "../../gcc/cp/cp-trait.gperf"
-      {"__is_volatile", CPTK_IS_VOLATILE, 1, false},
+      {"__is_unsigned", CPTK_IS_UNSIGNED, 1, false},
 #line 39 "../../gcc/cp/cp-trait.gperf"
       {"__has_virtual_destructor", CPTK_HAS_VIRTUAL_DESTRUCTOR, 1, false},
 #line 32 "../../gcc/cp/cp-trait.gperf"
@@ -207,6 +205,8 @@ cp_trait_lookup::find (const char *str, size_t len)
       {"__is_aggregate", CPTK_IS_AGGREGATE, 1, false},
 #line 42 "../../gcc/cp/cp-trait.gperf"
       {"__is_arithmetic", CPTK_IS_ARITHMETIC, 1, false},
+#line 45 "../../gcc/cp/cp-trait.gperf"
+      {"__is_base_of", CPTK_IS_BASE_OF, 2, false},
 #line 60 "../../gcc/cp/cp-trait.gperf"
       {"__is_nothrow_assignable", CPTK_IS_NOTHROW_ASSIGNABLE, 2, false},
 #line 62 "../../gcc/cp/cp-trait.gperf"
@@ -223,8 +223,8 @@ cp_trait_lookup::find (const char *str, size_t len)
       {"__is_abstract", CPTK_IS_ABSTRACT, 1, false},
 #line 44 "../../gcc/cp/cp-trait.gperf"
       {"__is_assignable", CPTK_IS_ASSIGNABLE, 2, false},
-#line 45 "../../gcc/cp/cp-trait.gperf"
-      {"__is_base_of", CPTK_IS_BASE_OF, 2, false},
+#line 64 "../../gcc/cp/cp-trait.gperf"
+      {"__is_pod", CPTK_IS_POD, 1, false},
 #line 67 "../../gcc/cp/cp-trait.gperf"
       {"__is_reference", CPTK_IS_REFERENCE, 1, false},
 #line 70 "../../gcc/cp/cp-trait.gperf"
@@ -242,19 +242,23 @@ cp_trait_lookup::find (const char *str, size_t len)
 #line 53 "../../gcc/cp/cp-trait.gperf"
       {"__is_final", CPTK_IS_FINAL, 1, false},
 #line 54 "../../gcc/cp/cp-trait.gperf"
-      {"__is_function", CPTK_IS_FUNCTION, 1, false}
+      {"__is_function", CPTK_IS_FUNCTION, 1, false},
+#line 87 "../../gcc/cp/cp-trait.gperf"
+      {"__is_deducible ", CPTK_IS_DEDUCIBLE, 2, false}
     };
 
   static const signed char lookup[] =
     {
-      -1, -1, -1, -1, -1, -1, -1,  0, -1,  1,  2,  3, -1, -1,
-       4, -1,  5,  6,  7,  8,  9, -1, 10, 11, -1, 12, -1, 13,
-      14, 15, 16, 17, 18, 19, -1, 20, 21, 22, 23, 24, 25, -1,
-      26, 27, 28, 29, -1, 30, 31, 32, 33, -1, 34, -1, 35, 36,
-      37, -1, 38, 39, 40, -1, -1, 41, 42, 43, 44, -1, 45, -1,
-      46, -1, -1, 47, -1, 48, -1, 49, -1, 50, 51, -1, -1, -1,
+      -1, -1, -1, -1, -1, -1, -1,  0, -1, -1, -1,  1, -1, -1,
+       2, -1,  3,  4,  5,  6,  7, -1,  8,  9, 10, 11, -1, 12,
+      13, 14, 15, 16, 17, 18, -1, 19, 20, 21, 22, 23, 24, -1,
+      25, 26, 27, 28, -1, 29, 30, 31, 32, -1, 33, -1, 34, 35,
+      36, -1, 37, 38, 39, -1, 40, 41, 42, 43, 44, -1, 45, -1,
+      46, -1, -1, 47, -1, 48, -1, -1, 49, 50, 51, -1, -1, -1,
       -1, 52, -1, -1, -1, -1, 53, 54, -1, 55, -1, 56, -1, -1,
-      -1, -1, 57, -1, -1, 58
+      -1, -1, 57, -1, -1, 58, -1, -1, -1, -1, -1, -1, -1, -1,
+      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
+      -1, -1, -1, -1, -1, -1, -1, -1, -1, 59
     };
 
   if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
diff --git a/gcc/cp/semantics.cc b/gcc/cp/semantics.cc
index deab0134509..14387821b85 100644
--- a/gcc/cp/semantics.cc
+++ b/gcc/cp/semantics.cc
@@ -12250,6 +12250,9 @@ trait_expr_value (cp_trait_kind kind, tree type1, tree type2)
     case CPTK_IS_UNION:
       return type_code1 == UNION_TYPE;
 
+    case CPTK_IS_UNSIGNED:
+      return TYPE_UNSIGNED (type1);
+
     case CPTK_IS_VOLATILE:
       return CP_TYPE_VOLATILE_P (type1);
 
@@ -12425,6 +12428,7 @@ finish_trait_expr (location_t loc, cp_trait_kind kind, tree type1, tree type2)
     case CPTK_IS_SCOPED_ENUM:
     case CPTK_IS_UNBOUNDED_ARRAY:
     case CPTK_IS_UNION:
+    case CPTK_IS_UNSIGNED:
     case CPTK_IS_VOLATILE:
       break;
 
diff --git a/gcc/testsuite/g++.dg/ext/has-builtin-1.C b/gcc/testsuite/g++.dg/ext/has-builtin-1.C
index 4bc85f4babb..3d380f94b06 100644
--- a/gcc/testsuite/g++.dg/ext/has-builtin-1.C
+++ b/gcc/testsuite/g++.dg/ext/has-builtin-1.C
@@ -164,6 +164,9 @@
 #if !__has_builtin (__is_union)
 # error "__has_builtin (__is_union) failed"
 #endif
+#if !__has_builtin (__is_unsigned)
+# error "__has_builtin (__is_unsigned) failed"
+#endif
 #if !__has_builtin (__is_volatile)
 # error "__has_builtin (__is_volatile) failed"
 #endif
diff --git a/gcc/testsuite/g++.dg/ext/is_unsigned.C b/gcc/testsuite/g++.dg/ext/is_unsigned.C
new file mode 100644
index 00000000000..2bb45d209a7
--- /dev/null
+++ b/gcc/testsuite/g++.dg/ext/is_unsigned.C
@@ -0,0 +1,47 @@
+// { dg-do compile { target c++11 } }
+
+#include <testsuite_tr1.h>
+
+using namespace __gnu_test;
+
+#define SA(X) static_assert((X),#X)
+#define SA_TEST_CATEGORY(TRAIT, X, expect) \
+  SA(TRAIT(X) == expect);                  \
+  SA(TRAIT(const X) == expect);            \
+  SA(TRAIT(volatile X) == expect);         \
+  SA(TRAIT(const volatile X) == expect)
+
+SA_TEST_CATEGORY(__is_unsigned, void, false);
+
+SA_TEST_CATEGORY(__is_unsigned, bool, (bool(-1) > bool(0)));
+SA_TEST_CATEGORY(__is_unsigned, char, (char(-1) > char(0)));
+SA_TEST_CATEGORY(__is_unsigned, signed char, false);
+SA_TEST_CATEGORY(__is_unsigned, unsigned char, true);
+SA_TEST_CATEGORY(__is_unsigned, wchar_t, (wchar_t(-1) > wchar_t(0)));
+SA_TEST_CATEGORY(__is_unsigned, short, false);
+SA_TEST_CATEGORY(__is_unsigned, unsigned short, true);
+SA_TEST_CATEGORY(__is_unsigned, int, false);
+SA_TEST_CATEGORY(__is_unsigned, unsigned int, true);
+SA_TEST_CATEGORY(__is_unsigned, long, false);
+SA_TEST_CATEGORY(__is_unsigned, unsigned long, true);
+SA_TEST_CATEGORY(__is_unsigned, long long, false);
+SA_TEST_CATEGORY(__is_unsigned, unsigned long long, true);
+
+SA_TEST_CATEGORY(__is_unsigned, float, false);
+SA_TEST_CATEGORY(__is_unsigned, double, false);
+SA_TEST_CATEGORY(__is_unsigned, long double, false);
+
+#ifndef __STRICT_ANSI__
+// GNU Extensions.
+#ifdef __SIZEOF_INT128__
+SA_TEST_CATEGORY(__is_unsigned, unsigned __int128, true);
+SA_TEST_CATEGORY(__is_unsigned, __int128, false);
+#endif
+
+#ifdef _GLIBCXX_USE_FLOAT128
+SA_TEST_CATEGORY(__is_unsigned, __float128, false);
+#endif
+#endif
+
+// Sanity check.
+SA_TEST_CATEGORY(__is_unsigned, ClassType, false);